Subject: bug#69689: closed (Re: bug#69689: 30.0.50; cannot native compile with -flto in native-comp-compiler-options)

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 02 Apr 2024 08:58:02 +0000

Your bug report

#69689: 30.0.50; cannot native compile with -flto in native-comp-compiler-options

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
69689: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=69689
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#69689: 30.0.50; cannot native compile with -flto in native-comp-compiler-options
From: Andrea Corallo <[email-masked]>
To: StrawberryTea <[email-masked]>
Cc: Björn Bidar <[email-masked]>, Eli Zaretskii <[email-masked]>, [email-masked], Paul Eggert <[email-masked]>
Date: Tue, 02 Apr 2024 04:56:48 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

StrawberryTea <[email-masked]> writes:

> Björn Bidar <[email-masked]> writes:
>
>> StrawberryTea <[email-masked]> writes:
>>
>>>>
>>>>   Andrea
>>>
>>> I see. I am going to report this to the GCC bug tracker to try and get
>>> it fixed. I would like to use LTO with native compilation, even if it
>>> would not bring any measurable advantages. And I feel there has to be
>>> some GCC person that knows how to fix this.
>>
>> Did you read my mail? I am able to compile elisp files with -flto in
>> native-comp-compiler-options.
>>
>> The errors must be somewhere on your side.
> Oh, I see. I did not read your mail. I am sorry for that. Thank you for
> the information. I will add this to the Gentoo bug report.

Hello all,

I'm closing this as I think this is not an Emacs bug.  Happy to re-open
if we discover it is :)

Thanks

  Andrea

Subject: 30.0.50; cannot native compile with -flto in native-comp-compiler-options
From: StrawberryTea <[email-masked]>
To: [email-masked]
Date: Sat, 09 Mar 2024 21:19:57 -0600
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello Emacs developers,

I am trying to native compile Emacs with the -flto flag patched into the
native-comp-compiler-options variable. However, when I do this, I get
the following error:

/usr/lib/gcc/x86_64-pc-linux-gnu/13/../../../../x86_64-pc-linux-gnu/bin/ld: /var/tmp/portage/app-editors/emacs-30.0.9999/temp/ccW8pLE7.o: plugin needed to handle lto object
/usr/lib/gcc/x86_64-pc-linux-gnu/13/../../../../x86_64-pc-linux-gnu/bin/ld: /var/tmp/portage/app-editors/emacs-30.0.9999/temp/ccW8pLE7.o: plugin needed to handle lto object
lto1: internal compiler error: original not compressed with zstd
0x11b434d internal_error(char const*, ...)
    ???:0
0x128df56 cgraph_node::get_untransformed_body()
    ???:0
0x128d4c3 cgraph_node::expand()
    ???:0
0x19c264f symbol_table::compile()
    ???:0
0x19b6f50 lto_main()
    ???:0
Please submit a full bug report, with preprocessed source (by using -freport-bug).
Please include the complete backtrace with any bug report.
See <https://bugs.gentoo.org/> for instructions.
make[4]: *** [/var/tmp/portage/app-editors/emacs-30.0.9999/temp/ccZwblRQ.mk:2: /var/tmp/portage/app-editors/emacs-30.0.9999/temp/ccq4BEJb.ltrans0.ltrans.o] Error 1
lto-wrapper: fatal error: make returned 2 exit status
compilation terminated.
collect2: fatal error: lto-wrapper returned 1 exit status
compilation terminated.
libgccjit.so: error: error invoking gcc driver

The full build log is here: https://0x0.st/HhAc.txt
Build environment: https://0x0.st/HhAT.txt
emerge --info output (I use Gentoo): https://0x0.st/HhAm.txt

Sincerely,
StrawberryTea